const newsApp = Vue.component('newsApp',{//only show mobile under HERO
  props:{
    'deviceW' : {
      type     : Number,
      default  : 1280,
    },
  },
  data : function(){
    let base       = location.protocol + "//" + location.host + '/';
    //dev address
    let devBase    = 'vli/';//dev directory
    let regDevBase = new RegExp("^([0-9]+)\.([0-9]+)\.([0-9]+)\.([0-9]+)$");//ipv4
    if(!(location.host.match(regDevBase)) && location.host != 'localhost'){
      devBase = '';
    }

    let fbHeight;
    if(this.deviceW <= 768){
      fbHeight = '400px';
    }else{
      fbHeight = '50VH';
    }

    return {
      'baseUrl'   : base,
      'devUrl'    : devBase,
      'newsTextA' : [],
      'toggleN'   : [],
      'styleSec' : {
        'min-height'     : '97vh',
        'margin-bottom'  : '0rem',
        'padding-bottom' : '1.5rem',
        'padding-top'    : '1.5rem',
      },
      'styleGFont' : {
        'font-family' : '"Poiret One", cursive',
      },
      'styleBorderRed' : {
        'border-bottom' : '#C00 1px solid',
      },
      'styleH3Mergin' : {
        'margin-bottom' : '1.5rem',
      },
      'styleFbpg' : {//kick bulma default iframe setting
        //'height'        : fbHeight,
        //'width'         : '278px',
        //'min-width'     : '278px',
        //'min-height'    : fbHeight,
        'margin-top'    : '1.5rem!important',
        'margin-bottom' : '1.5rem!important',
        'margin'  : '1.5rem auto!important',
      },
      'styleNewsBGI' : {
        'background-image'    : 'url(../img/news6.jpg)',
        'background-size'     : 'cover',
        'background-repeat'   : 'no-repeat',
        'background-potision' : 'bottom',
      },
      'styleNewsT' : {
        'margin-top'     : '1.5rem!important',
        'margin-bottom'  : '1.5rem!important',
      },
      'styleNewsTSP' : {
        'padding-top'    : '1.5rem',
        'padding-bottom' : '1.5rem',
        'padding-left'   : '1.875rem!important',
        'padding-right'  : '1.875rem!important',
        'margin-top'     : '0rem!important',
        'margin-bottom'  : '2.4rem!important',
      },
      'styleNewsTFigure' : {
        'margin' : '3rem 3rem',
      },
      'styleNewsTimeBorder' : {
        'color' : '#C00',
        'border-bottom' : '#C00 1px solid',
      },
      'styleGFont' : {
        'font-family' : '"Poiret One", cursive',
      },
      'styleBlack' : {
        'color' : '#222',
      },
      'styleRed' : {
        'color' : '#C00',
      },
      'styleBorderRed' : {
        'border-bottom' : '#C00 1px solid',
      },
      'styleBGI' : {
        'background-image'    : 'url("../img/server.jpg")',
        'background-repeat'   : 'no-repeat',
        'background-position' : 'center',
        'background-size'     : 'cover',
      },
      'styleQuarterVH'  : {
        'min-height' : '25VH',
      },
      'styleH3Mergin' : {
        'margin-bottom' : '1.5rem',
      },
    };
  },
  created(){
    let newsTexts = [];
    let newsImgs  = [];
    let newsNum   = 76;//取得記事数
    async function fNewsFetch(){
      for(let i = newsNum ; i >= 0 ; i--){
        fetch('../news/' + i + '.txt',{headers : {'Content-Type' : 'text/plain'}}).then(function(response){
          if(response.ok){
            response.text().then(function(text){
              let newsLines = [];
              let lines = text.split(/\r?\n/g);
              for(let line = 0; line < lines.length ; line++){
                newsLines[line] = lines[line] ? lines[line] : "　";
                newsLines.splice();
              }
              newsTexts[newsNum -i] = newsLines;// = text;//.replace(/\r?\n/g, '');//remove rn n
              newsTexts.splice();
              //写真あるかどうか
              //if(response.status == '200'){
              //  fetch('./' + i + '.jpg',{headers : {'Content-type' : 'image/jpeg'}}).then(function(response){
              //    response.blob().then(function(img){
              //      if(response.status == '200'){
              //        newsImgs[i] = img;// = img;
              //        newsImgs.splice();
              //      }
              //      if(response.status == '404'){
              //          newsImgs[i] = false;
              //          newsImgs.splice();
              //      }
              //    });
              //  });
              //}
            });
          }else{
            //throw new Error('got all');
          }
        });
      }
    }
    fNewsFetch();//sync fetch like xhr
    newsTexts.splice();
    this.newsTextA = newsTexts;

    let toggle = new Array(newsNum).fill(false,0,newsNum);
    toggle.splice();
    this.toggleN = toggle;
  },
  methods : {
    fToggle : function(x){
      this.toggleN[x] = true;
      this.toggleN.splice();
      return this.toggleN[x];
    }
  },
  template : `
  <div class="has-background-white-ter">
    <header class="hero is-medium marginless" :style="[styleBGI,styleBorderRed]">
      <div class="hero-body">
        <section class="container">
          <div class="columns" :style="styleQuarterVH">
            <div class="column is-4">
              <div class="is-vertical">
                <h1 class="is-size-2" :style="[styleGFont,styleRed,styleBorderRed]">NEWS</h1>
                <h2 class="subtitle is-size-5 has-text-white-bis" :style="styleGFont">archive</h2>
              </div>
            </div>
          </div>
        </section>
      </div>
    </header>
    <main class="section" :style="styleNewsBGI">
      <section class="container">
        <div class="columns">
          <div :class="[deviceW < 1024 ? 'is-12 column' : 'is-8 column']" :style="styleSec">
            <h3 v-if="deviceW > 768" class="is-size-2" :style="[styleGFont,styleBlack,styleBorderRed]">NEWS</h3>
                <article class="tile is-child box is-radiusless" :style="deviceW < 768 ? styleNewsTSP : styleNewsT" v-for="(value,item,index) in newsTextA" :v-key="newsTextA.index" v-if="value">
                  <p is-8 v-for="(val,itm,ind) in value" :v-key="itm" :style="itm == 0 ? styleRed : ''" :id="itm == 0 ? val : ''">
                    <span v-if="val == '' && toggleN[item]"><br></span>
                    <a v-if="val.match(/http/) && toggleN[item]" is-inline :href="val" target="_blank" rel="noopener">
                      こちら
                    </a>
                    <span v-else-if="itm == 0">{{val}}</span>
                    <span v-else-if="itm == 1">{{val}}<br><br v-show="toggleN[item]"><span><button class="button is-text is-small is-fullwidth is-radiusless" v-if="!toggleN[item]" @click.once="fToggle(item)">続きを見る</button></span></span>
                    <span v-else-if="toggleN[item]">{{val}}</span>
                  </p>
                </article>
          </div>
          <div v-if="deviceW >= 1024" :class="deviceW < 1024 ? '' : ['is-auto','column','has-text-centered']" :style="styleSec">
            <h3 class="is-size-2 has-text-left" :style="[styleGFont,styleBlack,styleBorderRed]">SNS</h3>
            <figure class="image is-64x64 is-inline-block" style="padding-top:1.5rem;margin-right:2rem;margin-bottom:1rem">
              <a href="https://www.facebook.com/VentureLaboInvestment/" target="_blank" rel="noopener"><img height="64" width="64" class="is-rounded" :src="baseUrl + devUrl + 'img/f_logo_b.png'" alt="Facebook link"></a>
           </figure>
           <figure class="image is-64x64 is-inline-block" style="padding-top:1.5rem;margin-bottom:1rem">
             <a href="https://twitter.com/venturelabo_vc" target="_blank" rel="noopener"><img class="is-rounded" height="64" width="64" :src="baseUrl + devUrl + 'img/t_logo_b.png'" alt="Twitter link"></a>
           </figure>
          </div>
        </div>
      </section>
    </main>
  </div>
  `
});

const team = new Vue({
  el : '#news',
  components:{
    'aNav'     : aNav,
    'app'      : newsApp,
    'aFooter'  : aFooter,
  },
  data : function(){
    return {
      'deviceW'   : window.innerWidth,
    };
  },
  template : `
    <div>
      <aNav :deviceW="deviceW">
      </aNav>
      <app :deviceW="deviceW">
      </app>
      <aFooter :deviceW="deviceW">
      </aFooter>
    </div>
  `,
});

